﻿imports Extensibility
imports System.Runtime.InteropServices

Imports Access = Microsoft.Office.Interop.Access
Imports System.Windows.Forms


#Region " Read me for Add-in installation and setup information. "
' When run, the Add-in wizard prepared the registry for the Add-in.
' At a later time, if the Add-in becomes unavailable for reasons such as:
'   1) You moved this project to a computer other than which is was originally created on.
'   2) You chose 'Yes' when presented with a message asking if you wish to remove the Add-in.
'   3) Registry corruption.
' you will need to re-register the Add-in by building the DOKO_AddInSetup project, 
' right click the project in the Solution Explorer, then choose install.
#End Region

<GuidAttribute("3616F809-1B06-47D3-9E8B-6AF9F87AE294"), ProgIdAttribute("DOKO_AddIn.Connect")> _
Public Class Connect
	
	Implements Extensibility.IDTExtensibility2

    Dim AccessApp As Access.Application
    Dim addInInstance As Microsoft.Office.Core.COMAddIn

    Private WithEvents _button1 As Access.CommandButton
    Private WithEvents _combo1 As Access.ComboBox
    Private WithEvents _form As Access.Form


	Private applicationObject As Object

	Public Sub OnBeginShutdown(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnBeginShutdown
	End Sub
	
	Public Sub OnAddInsUpdate(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnAddInsUpdate
	End Sub
	
	Public Sub OnStartupComplete(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnStartupComplete
	End Sub
	
	Public Sub OnDisconnection(ByVal RemoveMode As Extensibility.ext_DisconnectMode, ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnDisconnection
	End Sub
	
	Public Sub OnConnection(ByVal application As Object, ByVal connectMode As Extensibility.ext_ConnectMode, ByVal addInInst As Object, ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnConnection
        AccessApp = CType(application, Access.Application)
        addInInstance = CType(addInInst, Microsoft.Office.Core.COMAddIn)
        addInInstance.Object = Me
    End Sub

    Public Sub Info()
        MessageBox.Show("Hallo VB-User!")
    End Sub

    Public Sub ControlsAnbinden(ByVal btn As Access.CommandButton, _
                              ByVal cb As Access.ComboBox, ByVal frm As Access.Form)
        _button1 = btn
        _form = frm
        _combo1 = cb
        _button1.Caption = "Hier geht die Post ab ..."
        _button1.OnClick = "[Event Procedure]"
        _form.OnClose = "[Event Procedure]"
        _combo1.RowSourceType = "Wertliste"
        _combo1.AddItem("Zeile 1")
        _combo1.AddItem("Zeile 2")
        _combo1.AddItem("Zeile 3")
        _combo1.AddItem("Zeile 4")
        _combo1.AddItem("Zeile 5")
        _combo1.AddItem("Zeile 6")
        _form.Befehl0.Caption = "Klick mich ..."             ' Nicht schön, aber möglich
    End Sub

    Private Sub _button1_click() Handles _button1.Click
        Dim s As String
        MessageBox.Show("Button_Click")
        Dim f As New Form1
        f.TextBox1.Text = _combo1.RowSource.Replace(";", Chr(13) & Chr(10))
        f.ShowDialog()
        _combo1.RowSource = ""
        s = f.TextBox1.Text.Replace(Chr(13) & Chr(10), ";")
        _combo1.RowSource = s
    End Sub

    Private Sub _form_Close() Handles _form.Close
        MessageBox.Show("Und jetzt ist das Formular zu ....")
    End Sub

    Protected Sub Dispose()
        GC.Collect()
        Marshal.ReleaseComObject(AccessApp)
        AccessApp = Nothing
        Marshal.ReleaseComObject(_button1)
        _button1 = Nothing
        Marshal.ReleaseComObject(_combo1)
        _combo1 = Nothing
        Marshal.ReleaseComObject(_form)
        _form = Nothing
        Marshal.ReleaseComObject(addInInstance)
        addInInstance = Nothing
    End Sub


End Class
